         {Procedury trybu 13h wer. 1.0 Z WIRTUALNYM EKRANEM !!!!}
                              {GR_13_1}
                     {    1995-1-20/22 Warszawa   }

{  Procedury obslugujace ekran      wersja 1.0 by Sebastian Pawlak     }
{  Wszelkie prawa do kopiowania i rozpowszechniania zabronione, nawet  }
{  jesli autor wyrazi zgode !!!                                        }

UNIT GR_13_1;
Interface
 var Seg_vga,Ofs_vga:word;
 Function About:string; {zwraca autora}
 Procedure Initgraph (Tryb:byte); {ustala tryb graficzny}
 Function GetGraphMode:byte; {pobiera aktualny tryb graficzny}
 Procedure PutFullBitMap (Segment,Offse,Ilosc_bajtow:word); {Wyswietla obraz na caly ekran}
 Procedure GetFullBitMap (Segment,offse,Ilosc_bajtow:word); {Pobiera okreslony lancuch z ekranu}
 Procedure PutBitMap (X,Y,Segment,Offse:word); {Wyswietla obraz}
 Procedure GetBitMap (X1,Y1,X2,Y2:word;Segment,Offse:word); {Pobiera obraz}
 Procedure PutScaleBitMap (X,Y,Segment,Ofse:word;Skala_1,Skala_2:byte);
 Procedure PutSprite (X,Y,Segment,Offse:word;Omin_kolor,Od_kol,Do_kol:byte;Zwrot:byte); {Wyswietla sprite`a}
 Procedure PutScaleSprite (X,Y,Segment,Ofse:word;Omin_kolor,Zwrot,Skala_1,Skala_2:byte);
 Procedure Line (X1,Y1,X2,Y2:word;Kolor:byte); {Procedura kresli linie}
 Procedure Rectangle (X1,Y1,X2,Y2:word;Kolor:byte); {Kresli prostokat}
 Procedure TextXY (X,Y:integer;S:string;Kolor:byte); {Wyswietla tekst na ekranie}
 Procedure PutPixel (X,Y:word;Kolor:byte); {Wyswietla punkt na ekranie}
 Function  GetPixel (X,Y:word):byte; {Zwraca kolor punktu}
 Procedure SetRGBPalette (Kolor,R,G,B:byte); {Ustawia barwe danego koloru}
 Procedure SetRGBBlock (Od_kol,Il_kol:byte;Segment,offse:word); {Ustawia barwe bloku kolorow}
 Function GetMaxXBitMap (segment,offse:word):word; {podaje szerokosc bitmapy}
 Function GetMaxYBitMap (segment,offse:word):word; {podaje wysokosc bitmapy}
 Procedure Clearscreen (Kolor:byte); {czysci ekran}
 Procedure GraphWait; {czeka na powrot plamki.}
 Procedure MousePosition (X,Y:word); {ustawia pozycje myszy}
 Procedure ShowMouse; {pokazuje kursor myszy}
 Procedure HideMouse; {chowa kursor myszy}
 Function GetMousebutton:word; {zwraca stan przyciskow myszy}
 Function GetMouseX:word; {zwraca wspolrzedna X myszy}
 Function GetMouseY:word; {zwraca wspolrzedna Y myszy}
 Procedure MouseWindow (X1,Y1,X2,Y2:word); {ustawia zakres wychylen myszy}
 Procedure DefineGraphMouseShow (SelektorX,SelektorY,Segment,Offse:word); {definiuje ksztalt graficzny myszy}
 Procedure Okno (X,Y,X1,Y1:integer;S:string); {kresli okno w trybie tekstowym}
 Procedure BladOdczytu (s:string); {wyswietla informacje o bledzie odczytu}
 Procedure ShowOBR (X,Y:word;s:string;pa:boolean); {wyswietla obraz z dysku}
 Procedure Monitor_on; {wlacza obraz}
 Procedure Monitor_off; {wylacza monitor}

Implementation
Uses Crt,Dos;

{Zwraca do zmiennej string autora}
Function About:string;
begin
 About:='GR_13_1 wer. 1.0 - autor: Sebastian Pawlak. Wszelkie prawa zast.';
end;

{Ustala podany tryb graficzny np. 13H 320x200 256, 3H tekstowy}
Procedure Initgraph (Tryb:byte); assembler;
asm
 mov ah,0
 mov al,Tryb
 int 10h
end;

{Zwraca numer aktualnego trybu graficznego lub tekstowego}
Function GetGraphMode;
var Tryb:byte;
begin
 asm
  mov ah,0fh
  int 10h
  mov Tryb,al
 end;
 GetGraphMode:=Tryb;
end;

{Wyswietla obraz na caly ekran w punkcie 0,0}
Procedure PutFullBitMap (Segment,Offse,Ilosc_bajtow:word); assembler;
asm
 push ds {odlozenie na stos ds}
 push es {i es}

 mov si,Offse  {offset rysunku}
 add si,4       {do si}

 mov di,Ofs_vga       {poczatek ekranu}
 mov di,0
 mov cx,Ilosc_bajtow {ilosc bajtow do wyswietlenia DIV 2 !!!!!!!!!!!!}

 mov ax,Seg_vga  {przekazanie do}
 mov es,ax      {es adresu ekranu}
 mov ax,Segment {przekazanie do}
 mov ds,ax      {ds segmentu obrazu}
 rep movsb {przesuwa bajty na ekran}
 pop es {podniesienie ze stosu es}
 pop ds {i ds}
end;

{Pobiera obraz od punktu 0,0 do offsetu podanego jako ilosc_bajtow}
Procedure GetFullBitMap (Segment,Offse,Ilosc_bajtow:word); assembler;
asm
 push ds {odlozenie na stos ds}
 push es {i es}

 mov ax,Segment
 mov es,ax
 mov di,Offse
 mov ax,319
 mov es:[di],ax
 inc di
 inc di
 mov ax,199
 mov es:[di],ax

 mov di,Offse  {offset rysunku}
 add di,4       {do si}

 mov si,Ofs_vga       {poczatek ekranu}
 mov cx,Ilosc_bajtow {ilosc bajtow do wyswietlenia DIV 2 !!!!!!!!!!!!}

 mov ax,Segment {przekazanie do}
 mov es,ax      {ds segmentu obrazu}
 mov ax,Seg_vga  {przekazanie do}
 mov ds,ax      {es adresu ekranu}
 rep movsb {przesuwa bajty na ekran}
 pop es {podniesienie ze stosu es}
 pop ds {i ds}
end;

{Wyswietla obraz w puncie x,y. Szerokosc i wysokosc sa dane w zmiennej pointer}
Procedure PutBitMap (X,Y:word;Segment,Offse:word); assembler;
var MaxX,MaxY:word;
asm
 push ds {odklada na stosie ds}
 push es {i es}

 mov ax,Segment
 mov es,ax
 mov di,Offse
 mov ax,es:[di]
 mov MaxX,ax
 inc di
 inc di
 mov ax,es:[di]
 mov MaxY,ax

 mov dx,0
 mov ax,320 {<-- Oblicza offset na ekranie}
 mov bx,Y   {<-|}
 mul bx     {<-|}
 add ax,X   {<-|}
 mov di,ax       {poczatek ekranu}
 add di,Ofs_vga

 mov si,Offse   {offset rysunku+szerokosc i wysokosc}
 add si,4

 mov cx,MaxY    {Wysokosc obrazu}
 inc cx

 mov bx,MaxX    {Szerokosc obrazku}
 inc bx

 mov ax,Seg_vga  {przekazanie do}
 mov es,ax      {es adresu ekranu}
 mov ax,Segment {przekazanie do}
 mov ds,ax      {ds segmentu obrazu}

 {kresli linie}
@nastepna_linia:
 push cx
 mov cx,bx
 rep movsb {przesuwa bajty na ekran -cala linie}
 sub di,bx
 add di,320
 pop cx
 loop @nastepna_linia

 pop es {podniesienie ze stosu es}
 pop ds {i ds}
end;

{Pobiera fragment obrazu i zapamietuje go pod wskazanym adresem}
Procedure GetBitMap (X1,Y1,X2,Y2:word;Segment,Offse:word); assembler;
var MaxX,MaxY:word;
asm
 mov ax,X2
 sub ax,X1
 mov MaxX,ax
 mov ax,Y2
 sub ax,Y1
 mov MaxY,ax

 push ds {odklada na stosie ds}
 push es {i es}

 mov ax,Segment
 mov es,ax
 mov di,Offse
 mov ax,MaxX
 mov es:[di],ax
 inc di
 inc di
 mov ax,MaxY
 mov es:[di],ax

 mov ax,320 {<-- Oblicza offset na ekranie}
 mov bx,Y1  {<-|}
 mul bx     {<-|}
 add ax,X1  {<-|}
 mov si,ax       {poczatek ekranu}
 add si,Ofs_vga

 mov di,Offse   {offset rysunku+szerokosc i wysokosc}
 add di,4

 mov cx,MaxY    {Wysokosc obrazu}
 inc cx

 mov bx,MaxX    {Szerokosc obrazku}
 inc bx

 mov ax,Segment {przekazanie do}
 mov es,ax      {ds segmentu obrazu}
 mov ax,Seg_vga  {przekazanie do}
 mov ds,ax      {es adresu ekranu}

 {kresli linie}
@nastepna_linia:
 push cx
 mov cx,bx
 rep movsb {przesuwa bajty na ekran -cala linie}
 sub si,bx
 add si,320
 pop cx
 loop @nastepna_linia
 pop es {podniesienie ze stosu es}
 pop ds {i ds}
end;

{Procedura wyswietla skalowana bitmape}
Procedure PutScaleBitMap (X,Y,Segment,Ofse:word;Skala_1,Skala_2:byte);
var MaxX,MaxY:word;
    a,b,Skala_pion,PozY:word;
    col:byte;
begin
 MaxX:=GetMaxXBitMap (Segment,Ofse);
 MaxY:=GetMaxYBitMap (Segment,Ofse);
 for a:=1 to MaxX do
 begin
  Skala_pion:=X+a*Skala_1 div Skala_2;
  for b:=1 to MaxY do
  begin
   asm
    push es
    mov ax,Segment
    mov es,ax
    mov ax,b
    mov bx,MaxX
    inc bx
    mul bx
    add ax,a
    mov di,ax
    add di,Ofse
    add di,3
    mov al,es:[di]
    mov Col,al
    pop es
   end;
   PozY:=Y+b*Skala_1 div Skala_2;
   asm
    push es
    mov ax,Seg_vga
    mov es,ax
    mov ax,Skala_pion
    mov bx,PozY
    mov cl,6
    shl bx,cl
    mov cx,bx
    shl bx,1
    shl bx,1
    add bx,cx
    add bx,ax
    mov dl,Col
    add bx,Ofs_vga
    mov es:[bx],dl
    pop es
   end;
  end;
 end;
end;

{Wyswietla sprite`a na ekranie w tych miejscach gdzie w matrycy jest kolor}
{rozny od Omin_kolor}
{Jezeli na ekranie znajdzie sie punkt, ktorego wartosc bedzie >=Od_kol <=Do_kol}
{Wtedy w tym miejscu nie zostanie wyswietlony sprite.}
Procedure PutSprite (X,Y:word;Segment,Offse:word;Omin_kolor,
                                Od_kol,Do_kol:byte;Zwrot:byte); assembler;
var MaxX,MaxY:word;
asm
 push ds {odklada na stosie ds}
 push es {i es}

 mov ax,Segment
 mov es,ax
 mov di,Offse
 mov ax,es:[di]
 mov MaxX,ax
 inc di
 inc di
 mov ax,es:[di]
 mov MaxY,ax

 mov ax,320 {<-- Oblicza offset na ekranie}
 mov bx,Y   {<-|}
 mul bx     {<-|}
 add ax,X   {<-|}
 mov di,ax       {poczatek ekranu}
 add di,Ofs_vga

 mov si,Offse   {offset rysunku+szerokosc i wysokosc}
 add si,4

 mov cx,MaxY    {Wysokosc obrazu}
 inc cx

 mov bx,MaxX    {Szerokosc obrazku}
 inc bx

 mov dl,Omin_kolor {Kolor do ominiecia w matrycy}
 mov dh,Od_kol     {Kolor na ekranie, od ktorego nie mozna wyswietlac spritea}

 mov ax,Seg_vga  {przekazanie do}
 mov es,ax      {es adresu ekranu}

 mov ax,Segment {przekazanie do}
 mov ds,ax      {ds segmentu obrazu}

 cmp Zwrot,0
 jne @1
 jmp @2
@1:

 {bedzie bral kolejna linie}
@nastepna_linia:
 push cx
 mov cx,bx
 {wyswietla po jednym punkcie}
 @nastepny_punkt:
  mov al,ds:[si]
  cmp al,dl {jesli punkt to ten niedozwolony omija wyswietlanie}
  je @omin_wyswietlanie_punktu
  mov ah,es:[di]
  cmp ah,dh
  jb @wyswietl_punkt
  cmp ah,Do_kol
  jbe @omin_wyswietlanie_punktu
  @wyswietl_punkt:
  mov es:[di],al
  @omin_wyswietlanie_punktu:
  inc di
  inc si
 loop @nastepny_punkt
 sub di,bx  {ustawia sie w nastepnej linii}
 add di,320
 pop cx
 loop @nastepna_linia
 jmp @Koniec_spritea


@2:
 add di,bx
 dec di
 {bedzie bral kolejna linie}
@nastepna_linia_p:
 push cx
 mov cx,bx
 {wyswietla po jednym punkcie}
 @nastepny_punkt_p:
  mov al,ds:[si]
  cmp al,dl {jesli punkt to ten niedozwolony omija wyswietlanie}
  je @omin_wyswietlanie_punktu_p
  mov ah,es:[di]
  cmp ah,dh
  jb @wyswietl_punkt_p
  cmp ah,Do_kol
  jbe @omin_wyswietlanie_punktu_p
  @wyswietl_punkt_p:
  mov es:[di],al
  @omin_wyswietlanie_punktu_p:
  dec di
  inc si
 loop @nastepny_punkt_p
 add di,bx  {ustawia sie w nastepnej linii}
 add di,320
 pop cx
 loop @nastepna_linia_p

@Koniec_spritea:
 pop es {podniesienie ze stosu es}
 pop ds {i ds}
end;

{Procedura wyswietla skalowanego sprite`a}
Procedure PutScaleSprite (X,Y,Segment,Ofse:word;Omin_kolor,Zwrot,Skala_1,Skala_2:byte);
var MaxX,MaxY:word;
    a,b,Skala_pion,PozY:word;
    col,Blad:byte;
begin
 Blad:=0;
 MaxX:=GetMaxXBitMap (Segment,Ofse);
 MaxY:=GetMaxYBitMap (Segment,Ofse);
 for a:=1 to MaxX do
 begin
  if Zwrot=0 then Skala_pion:=X+a*Skala_1 div Skala_2
   else Skala_pion:=X+(MaxX-a)*Skala_1 div Skala_2;
  for b:=1 to MaxY do
  begin
   asm
    push es
    mov ax,Segment
    mov es,ax
    mov ax,b
    mov bx,MaxX
    inc bx
    mul bx
    add ax,a
    mov di,ax
    add di,Ofse
    add di,3
    mov al,es:[di]
    cmp al,Omin_kolor
    jne @omin_kol
    mov Blad,1
   @omin_kol:
    mov Col,al
    pop es
   end;
   if blad=0 then 
   begin
    PozY:=Y+b*Skala_1 div Skala_2;
    asm
     push es
     mov ax,Seg_vga
     mov es,ax
     mov ax,Skala_pion
     mov bx,PozY
     mov cl,6
     shl bx,cl
     mov cx,bx
     shl bx,1
     shl bx,1
     add bx,cx
     add bx,ax
     mov dl,Col
     add bx,Ofs_vga
     mov es:[bx],dl
     pop es
    end;
   end else blad:=0;
  end;
 end;
end;

{Procedura kresli linie miedzy punktem x1,y1 a x2,y2 o kolorze Kolor}
Procedure Line (X1,Y1,X2,Y2:word;Kolor:byte); assembler;
var DiffX,DiffY,Delt1,Delt2,Delt3,Delt4:word;
    Flipped:byte;
asm
 push es
 mov ax,0A000h
 mov es,ax
 mov ax,X1   {Wspolrzedne linii}
 mov bx,Y1
 mov si,X2
 mov di,Y2
 mov dl,Kolor

 mov Flipped,0
 sub ax,si
 cwd

 xor ax,dx
 sub ax,dx
 mov diffx,ax
 mov ax,bx
 sub ax,di
 cwd

 xor ax,dx
 sub ax,dx
 mov diffy,ax
 cmp ax,diffX
 jle @NoFlip

 mov Flipped,1
 mov diffX,ax
 mov ax,X1
 mov bx,Y1
 mov X1,bx
 mov Y1,ax
 mov ax,si
 mov si,di
 mov di,ax
@NoFlip:
 mov X2,si
 mov Y2,di
 mov ax,X1
 cmp ax,X2
 jle @NoFlip2
 mov ax,Y2
 mov bx,Y1
 mov Y1,ax
 mov Y2,bx
 mov ax,X2
 mov bx,X1
 mov X1,ax
 mov X2,bx
@NoFlip2:
 mov ax,Y2
 sub ax,Y1
 mov Diffy,ax
 shl ax,1
 mov delt2,ax
 sub ax,DiffX
 mov delt1,ax
 mov ax,diffY
 sub ax,DiffX
 shl ax,1
 mov Delt3,ax
 mov ax,diffY
 add ax,diffX
 shl ax,1
 mov delt4,ax
@LineLp:
 cmp Flipped,0
 jne @NoFlip3
 mov ax,X1
 mov bx,Y1
 jmp @Dl1
@NoFlip3:
 mov ax,Y1
 mov bx,X1
@Dl1:

 {obsluga wyswietlania pixela !!}
 mov cl,6
 shl bx,cl
 mov cx,bx
 shl bx,1
 shl bx,1
 add bx,cx
 add bx,ax
 mov dl,Kolor
 mov es:[bx],dl

 mov ax,X1
 cmp ax,X2
 jge @DlDone
 inc X1
 cmp Delt1,0
 jge @Dl2
 cmp DiffY,0
 jge @Dl3
 dec Y1
 mov ax,Delt4
 jmp @Dl4
@Dl2:
 cmp DiffY,0
 jle @Dl3
 inc Y1
 mov ax,Delt3
 jmp @Dl4
@Dl3:
 mov ax,Delt2
@Dl4:
 add delt1,ax
 jmp @LineLp
@DlDone:
 pop es
end;

{Kresli prostokat X1,Y2 do X2,Y2}
Procedure Rectangle (X1,Y1,X2,Y2:word;Kolor:byte); assembler;
asm
 push es
 mov ax,0A000h
 mov es,ax

 mov cx,X2  {Testowanie poprawnosci zapisu dla szerokosci}
 sub cx,X1
 cmp cx,0
 jge @omin_zamiane_szerokosci
 mov ax,X1
 mov bx,X2
 mov X1,bx
 mov X2,ax
@omin_zamiane_szerokosci:

 mov cx,Y2  {Testowanie poprawnosci zapisu dla wysokosci}
 sub cx,Y1
 cmp cx,0
 jge @omin_zamiane_wysokosci
 mov ax,Y1
 mov bx,Y2
 mov Y1,bx
 mov Y2,ax
@omin_zamiane_wysokosci:

 {Kreslenie linii poziomej GORNEJ i DOLNEJ}
 mov cx,Y2
 sub cx,Y1
 mov ax,320
 mul cx
 mov bx,ax
 push bx

 mov cx,X2
 sub cx,X1
 inc cx

 mov bx,Y1
 mov ax,320
 mul bx
 add ax,X1
 mov di,ax

 pop bx
 mov al,Kolor
@kresl_linie_pozioma:
 mov es:[di],al
 add di,bx
 mov es:[di],al
 sub di,bx
 inc di
 loop @kresl_linie_pozioma

 {Kreslenie linii pionowej LEWEJ I PRAWEJ}
 mov cx,X2
 sub cx,X1
 mov bx,cx
 push bx

 mov cx,Y2
 sub cx,Y1

 mov bx,Y1
 mov ax,320
 mul bx
 add ax,X1
 mov di,ax

 pop bx
 mov al,Kolor
@kresl_linie_pionowej:
 mov es:[di],al
 add di,bx
 mov es:[di],al
 sub di,bx
 add di,320
 loop @kresl_linie_pionowej
 pop es
end;

{Wyswietla tekst na ekranie -tylko w trybie graficznym}
Procedure TextXY (X,Y:integer;S:string;Kolor:byte);
var a,b,c:byte;
    kod:byte;
    poz:word;
    wiersz:byte;
    bit:array [0..7] of boolean;
begin
 for a:=1 to length (s) do
 begin
  kod:=ord (s [a]);
  for b:=0 to 7 do
  begin
   poz:=8*kod+$0fa6e+b;
   asm
    push ds
    mov ax,0f000h
    mov ds,ax
    mov si,poz
    mov al,ds:[si]
    pop ds
    mov wiersz,al
   end;
   for c:=0 to 7 do
   begin  
    if ((wiersz and 128)<>0) then PutPixel (X+(a-1)*8+c,Y+b,Kolor);
    wiersz:=wiersz shl 1;
   end;
  end;
 end;
end;

{Wyswietla punkt x,y o kolorze Kolor}
Procedure PutPixel (X,Y:word;Kolor:byte); assembler;
asm
 push es
 mov ax,Seg_vga
 mov es,ax
 mov ax,X
 mov bx,Y
 mov cl,6
 shl bx,cl
 mov cx,bx
 shl bx,1
 shl bx,1
 add bx,cx
 add bx,ax
 mov dl,Kolor
 add bx,Ofs_vga
 mov es:[bx],dl
 pop es
end;

{Zwraca kolor punktu o wspolrzednych X i Y}
Function GetPixel (X,Y:word):byte;
var Kolor:byte;
begin
 asm
  push es 
  mov ax,Seg_vga
  mov es,ax
  mov ax,X
  mov bx,Y
  mov cl,6
  shl bx,cl
  mov cx,bx
  shl bx,1
  shl bx,1
  add bx,cx
  add bx,ax
  add bx,Ofs_vga
  mov dl,es:[bx]
  mov Kolor,dl
  pop es
 end;
 GetPixel:=Kolor;
end;

{Ustawa barwe koloru Kolor wedlug trzech skladnikow: R, G, B}
Procedure SetRGBPalette (Kolor,R,G,B:byte); assembler;
var RGB:array [0..2] of byte;
asm
 push es
 mov ax,seg RGB
 mov es,ax
 mov di,offset RGB
 mov al,R
 mov es:[di],al
 inc di
 mov al,G
 mov es:[di],al
 inc di
 mov al,B
 mov es:[di],al
 dec di
 dec di
 mov dx,di

 mov ah,10h
 mov al,12h

 mov bl,Kolor
 mov cx,1
 int 10h

 mov dx,0
 pop es
end;

{Ustawia barwe bloku kolorow. Od kolor Od_kol do kolor Od_kol+Il_kol.}
{Palete pobiera spod adresu Segment:offse}
Procedure SetRGBBlock (Od_kol,Il_kol:byte;Segment,offse:word); assembler;
asm
 push es
 mov ax,Segment
 mov es,ax
 mov dx,offse

 mov ah,10h
 mov al,12h

 mov bl,Od_kol
 mov cl,Il_kol
 mov ch,0
 int 10h

 mov dx,0
 pop es
end;

{Funkcja zwraca szerokosc podanego obrazka pointer.}
Function GetMaxXBitMap (segment,offse:word):word;
var MaxX:word;
begin
 asm
  push es
  mov ax,segment
  mov es,ax
  mov di,offse
  mov ax,es:[di]
  mov MaxX,ax
  pop es
 end;
 GetMaxXBitMap:=MaxX;
end;

{Funkcja zwraca wysokosc podanego obrazka pointer.}
Function GetMaxYBitMap (segment,offse:word):word;
var MaxY:word;
begin
 asm
  push es
  mov ax,segment
  mov es,ax
  mov di,offse
  inc di
  inc di
  mov ax,es:[di]
  mov MaxY,ax
  pop es
 end;
 GetMaxYBitMap:=MaxY;
end;

{Czysci ekran - zamalowuje go na podany kolor.}
Procedure Clearscreen (Kolor:byte); assembler;
asm
 mov ax,Seg_vga
 mov es,ax
 mov di,Ofs_vga
 mov cx,32000
 mov al,Kolor
 mov ah,Kolor
 rep stosw
end;

{Czeka az plamka wroci na poczatek ekranu.}
Procedure GraphWait; assembler;
asm
 mov dx,03dah
@Czekaj_petla:
 in al,dx
 test al,8
 je @Czekaj_petla
end;

Procedure MousePosition (X,Y:word); assembler;
asm
 mov ax,04h
 mov cx,X
 mov dx,Y
 int 33h
end;

{Wyswietla z przerwania 33h kursor myszy w postaci zaleznej od trybu graf.}
Procedure ShowMouse; assembler;
asm
 mov ax,01h
 int 33h
end;

{Procedura chowa pokazany uprzednio kursor myszy.}
{Jezeli schowamy go dwa razy pod rzad to nalezy go tez dwa razy pokazac, aby}
{byl wyswietlony}
Procedure HideMouse; assembler;
asm
 mov ax,02h
 int 33h
end;

{Funkcja zwraca stan przyciskow myszy}
Function GetMouseButton:word;
var Button:word;
begin
 asm
  mov ax,03h
  int 33h
  mov Button,bx
 end;
 GetMouseButton:=Button; 
end;

{Funkcja zwraca wspolrzedna X myszy}
Function GetMouseX:word;
var X:word;
begin
 asm
  mov ax,03h
  int 33h
  mov X,cx
 end;
 GetMouseX:=X div 2;
end;

{Funkcja zwraca wspolrzedna Y myszy}
Function GetMouseY:word;
var Y:word;
begin
 asm
  mov ax,03h
  int 33h
  mov Y,dx
 end;
 GetMouseY:=Y;
end;

{Procedura ustala jak daleko mozna wychylic kursor myszy we wszystkie kierunki}
Procedure MouseWindow (X1,Y1,X2,Y2:word); assembler;
asm
 mov ax,07h
 mov cx,X1
 mov dx,X2
 int 33h
 mov ax,08h
 mov cx,Y1
 mov dx,Y2
 int 33h
end;

{Procedura definiuje ksztalt myszki i wyznacza selektor}
Procedure DefineGraphMouseShow (SelektorX,Selektory,Segment,Offse:word); assembler;
asm
 push es
 mov bx,SelektorX
 mov cx,SelektorY
 mov ax,Segment
 mov es,ax
 mov dx,Offse
 mov ax,9
 int 33h
 pop es
end;

{Procedura kresli okno w trybie tekstowym.}
procedure okno (x,y,x1,y1:integer;s:string);
var a:integer;
begin
 for a:=x+1 to x1-1 do
 begin
  gotoxy (a,y);
  write ('');
  gotoxy (a,y1);
  write ('');
 end;
 for a:=y+1 to y1-1 do
 begin
  gotoxy (x,a);
  write ('');
  gotoxy (x1,a);
  write ('');
 end;
 gotoxy (x,y);
 write ('');
 gotoxy (x1,y);
 write ('');
 gotoxy (x,y1);
 write ('');
 gotoxy (x1,y1);
 write ('');
 gotoxy (x+(x1-x) div 2-(length (s) div 2)-1,y);
 write (' ',s,' ');
end;

{Informuje o bledzie i albo ponawia probe odczytu albo wychodzi do dos`a}
Procedure BladOdczytu (s:string);
var obraz:pointer;
    a,b:integer;
begin
 if GetGraphMode=3 then
 begin
  textcolor (15);
  textbackground (blue);
  for b:=8 to 16 do
  begin
   gotoxy (25,b);
   write ('                              ');
  end;
  okno (25,8,55,16,'Blad odczytu !!!');
  gotoxy (29,9);
  Writeln ('Nie moge odczytac pliku');
  gotoxy (40-length (s) div 2,11);
  Writeln (s);
  gotoxy (29,13);
  Writeln ('Ponowic probe odczytu ?');
  textbackground (green);
  gotoxy (32,14);
  write (' TAK ');
  gotoxy (43,14);
  write (' NIE ');
  gotoxy (1,1);
  ShowMouse;
  repeat
   repeat until GetMouseButton=1;
  until ((((GetMouseX>=31*4)and(GetMouseX<=35*4))or((GetMouseX>=42*4)and(GetMouseX<=46*4)))and(GetMouseY=13*8));
  HideMouse;
  if ((GetMouseX>=42*4)and(GetMouseX<=46*4)) then
  begin
   textcolor (7);
   textbackground (0);
   clrscr;
   halt (0);
  end;
  textcolor (7);
  textbackground (0);
  clrscr;
 end else
 begin
  getmem (obraz,200*80);
  getbitmap (60,60,260,140,seg (obraz^),ofs (obraz^));
  rectangle (60,60,260,140,15);
  for a:=61 to 139 do line (61,a,259,a,0);
  textxy (160-16*8 div 2,65,'Blad odczytu !!!',15);
  textxy (160-23*8 div 2,78,'Nie moge odczytac pliku',15);
  textxy (160-length (s)*8 div 2,90,s,15);
  textxy (160-15*8 div 2,105,'Ponowic probe ?',15);
  rectangle (100,120,140,132,15);
  textxy (100,123,' TAK',15);
  rectangle (170,120,210,132,15);
  textxy (170,123,' NIE',15);
  ShowMouse;
  repeat
   repeat until GetMouseButton=1;
  until ((((GetMouseX>=100)and(GetMouseX<=140))
      or((GetMouseX>=170)and(GetMouseX<=210)))
       and((GetMouseY>=120)and(GetMouseY<=132)));
  HideMouse;
  if ((GetMouseX>=170)and(GetMouseX<=210)) then
  begin
   textcolor (7);
   textbackground (0);
   InitGraph (3);
   freemem (obraz,200*80);
   halt (0);
  end;
  putbitmap (60,60,seg (obraz^),ofs (obraz^));
  freemem (obraz,200*80);
 end;
end;

{Funkcja wewnetrzna. Zmienia litery w lancuchu na duze.}
Function UpString (s:string):string;
var Duze:string;
    a:integer;
begin
 Duze:='';
 for a:=1 to length (s) do Duze:=Duze+UpCase (s [a]);
 UpString:=Duze;
end;

{Procedura czyta z dysku i wyswietla w punkcie x,y obrazek (bitmape)}
Procedure ShowOBR (X,Y:word;s:string;pa:boolean);
var f:file;
    rezultat:word;
    opis_pliku:searchrec;
    IloscKolorow:byte;
    OdKoloru:byte;
    Paleta:array [0..256*3-1] of byte;
    Obr:pointer;
a:integer;
begin
 repeat
  findfirst (s,archive,opis_pliku);
  if opis_pliku.name<>upstring (s) then BladOdczytu (s);
 until opis_pliku.name=upstring (s);
 getmem (Obr,opis_pliku.size-(256*3+2));
 assign (f,s);
 reset (f,1);
 blockread (f,IloscKolorow,1,rezultat);
 blockread (f,OdKoloru,1,rezultat);
 blockread (f,Paleta,256*3,rezultat);
 blockread (f,Obr^,opis_pliku.size-(256*3+2));
 close (f);
 putbitmap (X,Y,seg (Obr^),ofs (Obr^));
 freemem (Obr,opis_pliku.size-(256*3+2));
 if pa=true then SetRGBBlock (OdKoloru,IloscKolorow,seg (Paleta),ofs (Paleta));
end;

procedure monitor_off;
begin
 port [$3C4]:=1;
 port [$3C5]:=port [$3C5] or $20;
end;

procedure monitor_on;
begin
 port [$3C4]:=1;
 port [$3C5]:=port [$3C5] and $DF;
end;

begin
 Seg_vga:=$0a000;
 ofs_vga:=0;
end.