{  Procedury obslugujace klawiature wersja 1.0 by Sebastian Pawlak     }
{  Wszelkie prawa do kopiowania i rozpowszechniania zabronione, nawet  }
{  jesli autor wyrazi zgode !!!                                        }

{  procedura Instaluj_obsluge_klawiatury instaluje obsluge             }
{  procedura Od... odinstalowuje                                       }
{  w zmiennej Znak jest ostatnio nacisniety znak                       }

UNIT OBS_KLAW;
Interface
var Znak:byte;
    Znak_wc:array [0..4] of byte;
 Procedure Instaluj_obsluge_klawiatury; {podmienia procedury obsl. klaw.}
 Procedure Odinstaluj_obsluge_klawiatury; {ustala stara proc. obsl. klaw.}

Implementation
Uses Dos;
var wektor_starej_obslugi_klawiatury:pointer;
    Kod_znaku,Kontrola:byte;

{Procedura, ktora bedzie obslugiwac przerwanie klawiatury}
{$F+}
Procedure Nowa_proc_obsl_klaw; interrupt;
var a,b,c:byte;
begin
 Kod_znaku:=port [$60]; {odczytuje kod znaku}
 Kontrola:=port [$61];
 port [$61]:=Kontrola or $80;
 port [$61]:=Kontrola;  {regeneracja sterowanika klawiatury}

 if Kod_znaku<=128 then
 begin
  for a:=0 to 3 do if znak_wc [a]=Kod_znaku then break
   else if znak_wc [a]=0 then
    begin
     for b:=3 downto 1 do znak_wc [b]:=Znak_wc [b-1];
     znak_wc [0]:=Kod_znaku;
     break;
    end;
 end else
 begin
  for a:=0 to 3 do
  if Kod_znaku=Znak_wc [a] or $80 then
  begin
   znak_wc [a]:=0;
   for b:=a+1 to 3 do znak_wc [b-1]:=Znak_wc [b];
   break;
  end;
 end;
 Znak:=znak_wc [0];
 port [$20]:=$20; {EOI}
end;
{$F-}

{Podmienia stary adres procedury obslugi klawiatury na nowy.}
Procedure Instaluj_obsluge_klawiatury;
begin
 SetIntVec ($9,@Nowa_proc_obsl_klaw);
end;

{Zapisuje na swoje miejsce stary adres procedury obslugi klawiatury}
Procedure Odinstaluj_obsluge_klawiatury;
begin
 Setintvec ($9,wektor_starej_obslugi_klawiatury);
end;

begin
 {zapamietuje w zmiennej stary adres procedury obslugi klawiatury}
 getintvec ($9,wektor_starej_obslugi_klawiatury);
end.